| C prototype: void FastOutlinedCircle_R(register void *plane asm("%a0"),register unsigned short xcenter asm("%d0"),register unsigned short ycenter asm("%d1"),register unsigned short radius asm("%d2"));
|
| Routine based on Exploder's routine written in C, using EXT_SETPIX.
| Rewritten in plain assembly by Lionel, using an algorithm different from
| that of Exploder's routine.
| Bench on a circle of radius 25 drawn at (30;30), real 89 HW2 AMS 2.05, 
| PRG_getStart() = 0xCE: 25 ticks to draw 2000 circles, ~1600 circles / sec,
| which is a ~70% speed increase compared to the recompiled and tweaked
| version of Exploder's routine, which draws ~930 circles / sec.

.data
.globl FastOutlinedCircle_R
.even

FastOutlinedCircle_R:
    movem.l  %d3-%d7/%a2-%a3,-(%sp)

    move.w   %d0,%d3 | xc
    lsr.w    #3,%d3 | byteoffset of xc from (0,yc)
    not.w    %d0
    andi.w   #7,%d0 | bit of xc.
    move.w   %d0,%d6 | save the bit number

    add.w    %d1,%d1 | yc
    move.w   %d1,%d4
    lsl.w    #4,%d4
    sub.w    %d1,%d4 | d4 = byteoffset of (0,yc) from (0,0)

    add.w    %d3,%d4 | d4 = byteoffset of (xc,yc) from (0,0)
    adda.w   %d4,%a0
    move.l   %a0,%a1
    move.l   %a1,%a2
    move.l   %a2,%a3


    move.w   %d2,%d1 | y = r
    clr.w    %d0 | x = 0
    moveq    #1,%d2
    sub.w    %d1,%d2
    add.w    %d2,%d2 | d = 2 * (1 - r) = 2 * (1 - y) at the beginning.

    move.w   %d1,%d3
    add.w    %d3,%d3
    move.w   %d3,%d5
    lsl.w    #4,%d5
    sub.w    %d3,%d5 | d5 = byteoffset of (0,y) from (0,0)

    suba.w   %d5,%a0
    suba.w   %d5,%a1
    adda.w   %d5,%a2
    adda.w   %d5,%a3

    move.w   %d6,%d3
    move.w   %d6,%d4
    move.w   %d6,%d5

__beginning_of_loop_FOC_R__:
    bset     %d3,(%a0)
    bset     %d4,(%a1)
    bset     %d5,(%a2)
    bset     %d6,(%a3)

| if(d + y > 0) {
    move.w   %d2,%d7
    add.w    %d1,%d7
    ble.s    __continue1_FOC_R__
| Short branches are faster if not taken.

    subq.w   #1,%d1 | y--
    sub.w    %d1,%d2
    sub.w    %d1,%d2
    addq.w   #1,%d2 | d -= (y * 2) - 1.

    moveq    #30,%d7
    adda.w   %d7,%a0
    adda.w   %d7,%a1
    suba.w   %d7,%a2
    suba.w   %d7,%a3

__continue1_FOC_R__:
| if(x > d) {
    cmp.w    %d0,%d2
    bge.s    __is_it_over_FOC_R__
| Short branches are faster if not taken.

    addq.w   #1,%d0 | x++
    add.w    %d0,%d2
    add.w    %d0,%d2
    addq.w   #1,%d2 | d += (x * 2) + 1;

    addq.w   #1,%d3
    cmpi.w   #7,%d3
    bls.s    __no_change1_FOC_R__
    subq.l   #1,%a0
    moveq    #0,%d3

__no_change1_FOC_R__:
    subq.w   #1,%d4
    bge.s    __no_change2_FOC_R__
    addq.l   #1,%a1
    moveq    #7,%d4

__no_change2_FOC_R__:
    addq.w   #1,%d5
    cmpi.w   #7,%d5
    bls.s    __no_change3_FOC_R__
    subq.l   #1,%a2
    moveq    #0,%d5

__no_change3_FOC_R__:
    subq.w   #1,%d6
    bge.s    __is_it_over_FOC_R__
    addq.l   #1,%a3
    moveq    #7,%d6

__is_it_over_FOC_R__:
    tst.w    %d1
    bge.s    __beginning_of_loop_FOC_R__


__end_FOC_R__:
    movem.l  (%sp)+,%d3-%d7/%a2-%a3
    rts
