| C prototype: void GraySprite32_ISHADOW_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),unsigned long *mask,register void *dest0 asm("%a0"),register void *dest1 asm("%a1")) __attribute__((__stkparm__));
|
| Original routine by geogeo (Geoffrey Anneheim). Rewritten by Lionel 
| Debroux (A68k assembly -> GNU assembly, optimized code, reduced size
| by using only one loop (using two loops for more speed doesn't make
| sense here), changed the code to take non-interlaced sprites).
| Modifications contributed back to geogeo, of course.

.data
.globl GraySprite32_ISHADOW_R
.even

GraySprite32_ISHADOW_R:
    dbf      %d2,__rest_of_GraySprite32_ISHADOW_R__
    rts

__rest_of_GraySprite32_ISHADOW_R__:
| Put loop counter on the stack so as to have more registers.
| The loop counter is used only once per iteration.
    movem.l  %d3-%d7/%a2-%a4,-(%sp)
    move.w   %d2,-(%sp)
    
    move.l   4+32+2(%sp),%a2

    |y*15
    move.w   %d1,%d2
    lsl.w    #4,%d1
    sub.w    %d2,%d1
    
    |x/16
    move.w   %d0,%d2
    lsr.w    #4,%d2
    
    add.w    %d2,%d1
    add.w    %d1,%d1
    adda.w   %d1,%a0
    adda.w   %d1,%a1
    	
    andi.w   #15,%d0          | d0=rightshift
    moveq.l  #16,%d1
    sub.w    %d0,%d1          | d1=lefshift

| Compute left mask and right mask at the same time.
    moveq    #-1,%d5
    lsr.w    %d0,%d5
    move.w   %d5,%d6
    not.l    %d5
    swap     %d5

| Put the two shift counts in the same register so as to have more 
| registers... The shift counts are used only once per iteration.
    swap     %d0
    move.w   %d1,%d0

| Here, d0/d5/d6 and a0-a2 contain relevant data.
_loop_GraySprite32_ISHADOW_R:
    move.l   (%a0)+,%d1
    move.w   (%a0),%d2
    move.l   (%a1)+,%d3
    move.w   (%a1),%d4

    and.l    %d3,%d1
    and.w    %d4,%d2
    move.w   (%a0),%d7
    not.w    %d7
    and.w    %d7,%d4
    move.l   -(%a0),%d7
    not.l    %d7
    and.l    %d7,%d3
| d1,d2 = new dark.
| d3,d4 = new light.

| Save d1
    move.l   %d1,%a3

| Mask.
    move.l   (%a2)+,%d1
    move.w   %d1,%d7
    lsl.w    %d0,%d7
    swap     %d0
    lsr.l    %d0,%d1
    swap     %d0
    or.l     %d5,%d1
    or.w     %d6,%d7
    and.l    %d1,(%a0)+
    and.w    %d7,(%a0)
    and.w    %d7,(%a1)
    and.l    %d1,-(%a1)
    not.l    %d1
    not.w    %d7

| Shadow area.
    and.l    %d1,%d3
    and.w    %d7,%d4
    or.w     %d4,(%a0)
    or.l     %d3,-(%a0)

    move.l   %a3,%d4
    and.l    %d1,%d4
    and.w    %d7,%d2
    or.l     %d4,(%a1)+
    or.w     %d2,(%a1)

    lea      30(%a0),%a0
    lea      30-4(%a1),%a1

    subq.w   #1,(%sp)
    bge.s    _loop_GraySprite32_ISHADOW_R

    addq.l   #2,%sp
    movem.l  (%sp)+,%d3-%d7/%a2-%a4
    rts
